// DELLIST.PRG lists deleted files in a given directory and their information 
// typical usage: DELLIST SYS:PUBLIC\*.*                              

#include "novlib.ch"

Local cName := ""
Local nCounter := 0

parameters cCommand

cCommand := if( cCommand != NIL , cCommand, GetNetPath(CurrDrive()) )

SET DATE BRITISH

? "File Name    Del Date Del Time Deletor    Mod Date Mod Time Acc Date "
? "---------------------------------------------------------------------"

cName := DFileName( cCommand )

do while !( empty( cName ) )

  ? padr(cName,12),DFilDDate(),DFilDTime(),padr(objectname(DFileDelID()),10),DFilMDate(),DFilMTime(),DFilAcDate()

  cName := DFileName()

  nCounter++

enddo

?
? nCounter," deleted files in directory ",cCommand
?

