******************************************************************************
*                                                                            *
* LT.PRG for NOVLIB V2.1                                                     *
* NOVLIB test program                                                        *
* Copyright (C) 1990-1994 ASM Inc     .  All Rights Reserved.                *
* by Goth & Alan Baldwin                                                     *
*                                                                            *
******************************************************************************

parameters CmdLine
CmdLine = iif(type("CmdLine") = "U", "", CmdLine)

#include "novlib.ch"

save screen to oldscreen

clear

set escape on
set scoreboard off
setcancel(.t.)
set cursor on
set date british
set confirm on
set bell off
set exclusive off
set deleted on
set wrap on

public FuncName,Hist,array_ptr
Hist = {}
array_ptr = 0
set key 5 to LastFunc()
set Key 24 to LastFunc()

@0,0 say "NOVLIB Library Test V2.1"
@1,0 to 1,79
@11,0 to 11,79

@22,0 to 22,79 double

set color to "w/n,w/n"

do while .t.

  @3,0 say "    Function:"
  @4,0 say "Return Value:"
  @5,0 say " Output Type:"
  @6,0 say "     NWError:"
  @7,0 say "      Memory:"
  @8,0 say "    BlMemory:"

  FuncName = space(72)
  @21,0 say "NL>" get FuncName

  clear typeahead
  read

  @ 3,0 clear to 7,79

  if lastkey() = 27
    exit
  elseif FuncName # " "
    if !type(alltrim(FuncName)) == "UI" .AND. !( ":=" $ FuncName )
      scroll(12,0,21,79,1)
      @21,0 say "NL> function not found"
    else
      aadd(Hist,FuncName)
      array_ptr = len(Hist)
      RetVal = &FuncName
      @3,14 say FuncName
      @4,14 say RetVal
      @5,14 say type("RetVal")
      @6,14 say ltrim(str(NWError()))+if( Gothic(), "*"," " )
      @7,14 say ltrim(str(memory(0)*1024))
*      @8,14 say ltrim(str(blimemavl()))
    endif
  endif
  OldFunc = FuncName
  scroll(12,0,21,79,1)
enddo
set color to

restore screen from oldscreen

@ 24,0

RETURN

function cls

@12,0 clear to 21,79

return .t.


proc LastFunc()

if LastKey() = 5 .and. array_ptr > 1
  FuncName = Hist[ if(FuncName=" ",array_ptr,--array_ptr)]
elseif LastKey() = 5 .and. array_ptr = 1
  FuncName = Hist[array_ptr]
elseif LastKey() = 24 .and. array_ptr < len(Hist)
  FuncName = Hist[++array_ptr]
elseif LastKey() = 24
  FuncName = space(72)
endif

return

