// slist.prg
//
// this does not do a GetAllKnownServers, it just sees servers known
// to the current server.
//
// by Goth.
//

#include "novlib.ch"

LOCAL cDefServer, cServerName, cNode, cAddress, cStatus, nCounter

cDefServer := FSName()

if !empty( cDefServer )

  ? "Known NetWare File Servers             Network   Node Address     Status"
  ? "------------------------------------------------------------------------"

  cServerName := BindSearch( "*", OT_FILE_SERVER )

  do while !empty( cServerName )

    cNode := "["

    for nCounter = 1 to 4
      cNode := cNode + right( strtran( strhex( ReadPByte( cServerName,;
                 OT_FILE_SERVER, "NET_ADDRESS", nCounter ) )," ", "0" ), 2 )
    next

    cNode := cNode + "]"

    cAddress := "["

    for nCounter = 5 to 10
      cAddress := cAddress + right( strtran( strhex( ReadPByte( cServerName,;
                 OT_FILE_SERVER, "NET_ADDRESS", nCounter ) )," ", "0" ), 2 )
    next

    cAddress := cAddress + "]"

    cStatus := ""

    if ( cDefServer == cServerName )
      cStatus := "Default"
    elseif FSConnNo( cServerName ) > 0
      cStatus := "Attached"
    endif

    ? padr( cServerName, 36 )+" "+cNode+" "+cAddress+"    "+cStatus

    cServerName := BindSearch()

  enddo

  ?
  ?

endif

