// DLIST.PRG lists the directories and their information //
// for a given path                                      //
// typical usage: DLIST SYS:DATA\*                       //

#include "novlib.ch"

Local cName := ""

parameters cCommand

cCommand := if( cCommand != NIL , cCommand, GetNetPath(CurrDrive()) + "\*" )

SET DATE BRITISH

? "Dir Name     Mod Date Mod Time Owner      Cre Date Cre Time Inh Rights"
? "----------------------------------------------------------------------"

cName := DirName( cCommand )

do while !( empty( cName ) )

  ? padr(cName,12),DirModDate(),DirModTime(),padr(objectname(DirownerID()),10),DirDate(),DirTime(),TrustMask(DirIRMask())

  cName := DirName()

enddo

?
