// FLIST.PRG lists files in a given directory and their information //
// typical usage: FLIST SYS:PUBLIC\*.*                              //


#include "novlib.ch"

Local cName := ""

parameters cCommand

cCommand := if( cCommand != NIL , cCommand, GetNetPath(CurrDrive()) + "\*" )

SET DATE BRITISH

? "File Name    Mod Date Mod Time Owner      Cre Date Cre Time Acc Date InhRights"
? "------------------------------------------------------------------------------"

cName := FileName( cCommand )

do while !( empty( cName ) )

  ? padr(cName,12),FilModDate(),FilModTime(),padr(objectname(FilownerID()),10),FileDate(),FileTime(),FilAccDate(),TrustMask(FileIRMask())

  cName := FileName()

enddo

?
